<script lang="ts">
  import '../../app.scss';
  import Notifications from 'svelte-notifications';
  import Navbar from '$lib/layout/Navbar.svelte';
  import Env from '$lib/env';
  import { Alert, Spinner } from 'flowbite-svelte';
  import { writable } from 'svelte/store';
  import { createClient } from '$lib/oidc';
  import { Log } from 'oidc-client-ts';

  let displayHelp = false;
  const authStatusStore = writable('not initialized');

  async function initializeAuth() {
    setTimeout(() => (displayHelp = true), 5000);
    // Initialize OIDC Client
    const client = await createClient({
      trySilentAuth: true,
      oidcLogLevel: Log.INFO,
      statusStore: authStatusStore,
    });
    console.debug('OIDC Client initialized', client);
  }
</script>

<main class="flex h-full flex-grow flex-col">
  {#if Env.IntercomWarning}
    <Alert class="m-2" color="orange">{Env.IntercomWarning}</Alert>
  {/if}
  {#if Env.IntercomError}
    <Alert class="m-2" color="red">{Env.IntercomError}</Alert>
  {/if}

  <Notifications>
    <Navbar />
    <div class="mx-auto w-full flex-grow">
      {#await initializeAuth()}
        <div class="container mx-auto flex flex-col items-center justify-center gap-8 p-12 text-xl dark:text-white">
          <Spinner size="32" color="blue" />
          <p>Loading Application...</p>
          {#if displayHelp}
            <p>
              This is taking longer than expected. Please reach out to
              <!-- todo configure support email -->
              <a href="mailto:">support</a> if the problem persists.
            </p>
          {/if}
        </div>
      {:then _}
        <slot />
      {/await}
    </div>
  </Notifications>

  <footer class="flex items-center p-3 dark:bg-gray-800 dark:text-white">
    <p class="mx-auto">Footer contents here</p>
  </footer>
</main>
